Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 1937)
+++ palm/trunk/SOURCE/Makefile	(revision 1938)
@@ -20,5 +20,5 @@
 # Current revisions:
 # ------------------
-# 
+# Some dependency errors corrected 
 # 
 # Former revisions:
@@ -349,5 +349,15 @@
 LDFLAGS =
 
-#to_be_replaced_by_include
+#BOUNDS="-Rbc"  # Array bounds checking. Compromises performance seriously.
+
+F90 = ftn
+#COPT = -DMPI_REAL=MPI_DOUBLE_PRECISION -DMPI_2REAL=MPI_2DOUBLE_PRECISION -D__lc -D__parallel -D__fftw \
+#             -D__netcdf -D__netcdf4 -D__netcdf4_parallel -D__nopointer
+COPT = -DMPI_REAL=MPI_DOUBLE_PRECISION -DMPI_2REAL=MPI_2DOUBLE_PRECISION -D__lc -D__parallel -D__fftw \
+             -D__netcdf -D__netcdf4 -D__netcdf4_parallel
+
+#F90FLAGS = -O2 -e Fm -G2 -rm $(BOUNDS) -hnoomp
+F90FLAGS = -O2 -e F -G2 -rm $(BOUNDS) -hnoomp
+LDFLAGS = $(F90FLAGS) -dynamic
 
 .SUFFIXES:
@@ -378,7 +388,7 @@
 advec_w_pw.o: modules.o mod_kinds.o
 advec_w_up.o: modules.o mod_kinds.o
-average_3d_data.o: modules.o cpulog_mod.o mod_kinds.o land_surface_model_mod.o\
+average_3d_data.o: modules.o cpulog_mod.o mod_kinds.o land_surface_model_mod.o \
                    radiation_model_mod.o
-boundary_conds.o: modules.o mod_kinds.o
+boundary_conds.o: modules.o mod_kinds.o pmc_interface_mod.o
 buoyancy.o: modules.o mod_kinds.o
 calc_mean_profile.o: modules.o mod_kinds.o
@@ -406,7 +416,7 @@
    spectra_mod.o
 data_output_tseries.o: modules.o cpulog_mod.o mod_kinds.o netcdf_interface_mod.o
-data_output_2d.o: modules.o cpulog_mod.o mod_kinds.o mod_particle_attributes.o\
+data_output_2d.o: modules.o cpulog_mod.o mod_kinds.o mod_particle_attributes.o \
    netcdf_interface_mod.o land_surface_model_mod.o radiation_model_mod.o
-data_output_3d.o: modules.o cpulog_mod.o mod_kinds.o mod_particle_attributes.o\
+data_output_3d.o: modules.o cpulog_mod.o mod_kinds.o mod_particle_attributes.o \
    netcdf_interface_mod.o land_surface_model_mod.o
 diffusion_e.o: modules.o mod_kinds.o microphysics_mod.o \
@@ -417,12 +427,12 @@
 diffusion_w.o: modules.o mod_kinds.o wall_fluxes.o
 diffusivities.o: modules.o mod_kinds.o
-disturb_field.o: modules.o cpulog_mod.o mod_kinds.o random_function_mod.o\
+disturb_field.o: modules.o cpulog_mod.o mod_kinds.o random_function_mod.o \
                  random_generator_parallel_mod.o
 disturb_heatflux.o: modules.o cpulog_mod.o mod_kinds.o
 eqn_state_seawater.o: modules.o mod_kinds.o
 exchange_horiz.o: modules.o cpulog_mod.o mod_kinds.o
-exchange_horiz_2d.o: modules.o cpulog_mod.o mod_kinds.o
+exchange_horiz_2d.o: modules.o cpulog_mod.o mod_kinds.o pmc_interface_mod.o
 fft_xy_mod.o: cuda_fft_interfaces_mod.o modules.o mod_kinds.o singleton_mod.o temperton_fft_mod.o
-flow_statistics.o: modules.o cpulog_mod.o mod_kinds.o land_surface_model_mod.o\
+flow_statistics.o: modules.o cpulog_mod.o mod_kinds.o land_surface_model_mod.o \
    netcdf_interface_mod.o radiation_model_mod.o
 global_min_max.o: modules.o mod_kinds.o
@@ -444,5 +454,5 @@
 init_masks.o: modules.o mod_kinds.o netcdf_interface_mod.o
 init_ocean.o: modules.o eqn_state_seawater.o mod_kinds.o
-init_pegrid.o: modules.o mod_kinds.o spectra_mod.o
+init_pegrid.o: modules.o mod_kinds.o spectra_mod.o pmc_interface_mod.o
 init_pt_anomaly.o: modules.o mod_kinds.o
 init_rankine.o: modules.o mod_kinds.o
@@ -495,7 +505,7 @@
    radiation_model_mod.o microphysics_mod.o wind_turbine_model_mod.o
 plant_canopy_model_mod.o: modules.o mod_kinds.o
-pmc_interface_mod.o: modules.o mod_kinds.o pmc_child_mod.o pmc_general_mod.o\
+pmc_interface_mod.o: modules.o mod_kinds.o pmc_child_mod.o pmc_general_mod.o \
 	pmc_handle_communicator_mod.o pmc_mpi_wrapper_mod.o pmc_parent_mod.o
-pmc_child_mod.o: mod_kinds.o pmc_general_mod.o pmc_handle_communicator_mod.o\
+pmc_child_mod.o: mod_kinds.o pmc_general_mod.o pmc_handle_communicator_mod.o \
    pmc_mpi_wrapper_mod.o
 pmc_general_mod.o: mod_kinds.o
@@ -506,5 +516,5 @@
 poismg_mod.o: modules.o cpulog_mod.o mod_kinds.o
 poismg_noopt.o: modules.o cpulog_mod.o mod_kinds.o
-pres.o: modules.o cpulog_mod.o mod_kinds.o poisfft_mod.o poismg_mod.o
+pres.o: modules.o cpulog_mod.o mod_kinds.o poisfft_mod.o poismg_mod.o pmc_interface_mod.o
 print_1d.o: modules.o cpulog_mod.o mod_kinds.o
 production_e.o: modules.o mod_kinds.o wall_fluxes.o
@@ -532,9 +542,9 @@
 spectra_mod.o: spectra_mod.f90 modules.o mod_kinds.o cpulog_mod.o fft_xy_mod.o
 subsidence_mod.o: modules.o mod_kinds.o
-sum_up_3d_data.o: modules.o cpulog_mod.o mod_kinds.o land_surface_model_mod.o\
+sum_up_3d_data.o: modules.o cpulog_mod.o mod_kinds.o land_surface_model_mod.o \
                   radiation_model_mod.o 
 surface_coupler.o: modules.o cpulog_mod.o mod_kinds.o
 surface_layer_fluxes_mod.o: modules.o mod_kinds.o land_surface_model_mod.o
-swap_timelevel.o: modules.o cpulog_mod.o mod_kinds.o land_surface_model_mod.o\
+swap_timelevel.o: modules.o cpulog_mod.o mod_kinds.o land_surface_model_mod.o \
    pmc_interface_mod.o
 temperton_fft_mod.o: modules.o mod_kinds.o
Index: palm/trunk/SOURCE/pmc_handle_communicator_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_handle_communicator_mod.f90	(revision 1937)
+++ palm/trunk/SOURCE/pmc_handle_communicator_mod.f90	(revision 1938)
@@ -1,3 +1,3 @@
- MODULE PMC_handle_communicator
+  MODULE PMC_handle_communicator
 
 !-------------------------------------------------------------------------------!
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Minor clean-up.
 ! 
 ! Former revisions:
@@ -526,5 +526,5 @@
        ENDDO
        IF ( bad_llcorner /= 0)  THEN
-          WRITE ( message_string, *)  'Lower left corners do not match,',       &
+          WRITE ( message_string, *)  'lower left corners do not match,',       &
                                       'they were set to (0, 0)'
           CALL message( 'read_coupling_layout', 'PA0427', 0, 0, 0, 6, 0 )
Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 1937)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 1938)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Minor clean-up.
 ! 
 ! Former revisions:
@@ -714,5 +714,5 @@
        CALL MPI_BCAST( nomatch, 1, MPI_INTEGER, 0, comm2d, ierr )
        IF ( nomatch /= 0 ) THEN
-          WRITE ( message_string, * )  'Error: nested child domain does ',      &
+          WRITE ( message_string, * )  'nested child domain does ',             &
                                        'not fit into its parent domain'
           CALL message( 'pmci_setup_parent', 'PA0425', 3, 2, 0, 6, 0 )
@@ -721,6 +721,5 @@
        CALL MPI_BCAST( nest_overlap, 1, MPI_INTEGER, 0, comm2d, ierr )
        IF ( nest_overlap /= 0 ) THEN
-          WRITE ( message_string, * )  'Nested parallel child ',    &
-                                       'domains overlap'
+          WRITE ( message_string, * )  'nested parallel child domains overlap'
           CALL message( 'pmci_setup_parent', 'PA0426', 3, 2, 0, 6, 0 )
        ENDIF
Index: palm/trunk/SOURCE/pmc_parent_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_parent_mod.f90	(revision 1937)
+++ palm/trunk/SOURCE/pmc_parent_mod.f90	(revision 1938)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Minor clean up.
 ! 
 ! Former revisions:
@@ -541,5 +541,5 @@
           IF ( ar%sendindex + ar%sendsize > bufsize )  THEN             
              WRITE( message_string, '(a,i4,4i7,1x,a)' )                         &
-                    'Parent buffer too small ',i,                               &
+                    'parent buffer too small ',i,                               &
                     ar%sendindex,ar%sendsize,ar%sendindex+ar%sendsize,          &
                     bufsize,trim(ar%name)