Index: /palm/trunk/SCRIPTS/.mrun.config.kiaps
===================================================================
--- /palm/trunk/SCRIPTS/.mrun.config.kiaps	(revision 1939)
+++ /palm/trunk/SCRIPTS/.mrun.config.kiaps	(revision 1940)
@@ -25,17 +25,16 @@
 # required paths (given in <>) by the respective paths valid on your host.
 #
-%login_init_cmd      .:/cm/local/apps/environment-modules/3.2.6/init/ksh  lckiaps parallel
-%modules             pgi/11.10:PrgEnv-pgi/1.1:mpich2/1.4.1p1:netcdf       lckiaps parallel
-%tmp_user_catalog    /home/data/<replace_by_your_kiaps_username>          lckiaps parallel
-%tmp_data_catalog    /home/data/<replace_by_your_kiaps_username>          lckiaps parallel
+%modules             intel/2016.1:PrgEnv-intel/2016.1:mvapich2/1.8.1:netcdf/4.1.3   lckiaps parallel
+%tmp_user_catalog    /home/<replace by your kiaps username>/data                 lckiaps parallel
+%tmp_data_catalog    /home/<replace by your kiaps username>/data                 lckiaps parallel
 %compiler_name       mpif90                            lckiaps parallel
-%compiler_name_ser   pgf90                             lckiaps parallel
-%cpp_options         -Mpreprocess:-DMPI_REAL=MPI_DOUBLE_PRECISION:-DMPI_2REAL=MPI_2DOUBLE_PRECISION:-D__netcdf lckiaps parallel
-%netcdf_inc          -I:/opt/kiaps/apps/netcdf/4.1.3/pgi/11.10/include  lckiaps parallel
-%netcdf_lib          -L/opt/kiaps/apps/netcdf/4.1.3/pgi/11.10/lib:-lnetcdf:-lnetcdff  lckiaps parallel
+%compiler_name_ser   ifort                             lckiaps parallel
+%cpp_options         -cpp:-DMPI_REAL=MPI_DOUBLE_PRECISION:-DMPI_2REAL=MPI_2DOUBLE_PRECISION:-D__netcdf:-D__netcdf4 lckiaps parallel
+%netcdf_inc          -I:/app/compilers/intel_2015/applib1/NETCDF4/4.1.3/include  lckiaps parallel
+%netcdf_lib          -L/app/compilers/intel_2015/applib1/NETCDF4/4.1.3/lib:-lnetcdf:-lnetcdff  lckiaps parallel
 %mopts               -j:4                              lckiaps parallel
-%fopts               -fastsse                          lckiaps parallel
-%lopts               -fastsse                          lckiaps parallel
-%remote_username     <replace_by_your_kiaps_username>  lckiaps parallel
+%fopts               -fpe0:-O3:-fp-model:source:-ftz:-fno-alias:-no-prec-div:-no-prec-sqrt:-ip:-nbs  lckiaps parallel
+%lopts               -fpe0:-O3:-fp-model:source:-ftz:-fno-alias:-no-prec-div:-no-prec-sqrt:-ip:-nbs  lckiaps parallel
+%remote_username     <replace by your kiaps username>  lckiaps parallel
 %memory              1500                              lckiaps parallel
 #             
Index: /palm/trunk/SCRIPTS/mrun
===================================================================
--- /palm/trunk/SCRIPTS/mrun	(revision 1939)
+++ /palm/trunk/SCRIPTS/mrun	(revision 1940)
@@ -22,5 +22,5 @@
 # Current revisions:
 # ------------------
-# 
+# adjustments for lckiaps
 # 
 # Former revisions:
@@ -3162,5 +3162,5 @@
                    elif [[ $host = lckiaps ]]
                    then
-                      mpirun -np $ii  -f $PBS_NODEFILE  a.out  <  runfile_atmos
+                      mpirun -np $ii  -machinefile $PBS_NODEFILE  ./a.out  <  runfile_atmos
                    elif [[ $host = lckyu* ]]
                    then
Index: /palm/trunk/SCRIPTS/subjob
===================================================================
--- /palm/trunk/SCRIPTS/subjob	(revision 1939)
+++ /palm/trunk/SCRIPTS/subjob	(revision 1940)
@@ -23,5 +23,5 @@
 # Current revisions:
 # ------------------
-# 
+# adjustments for lckiaps
 # 
 # Former revisions:
@@ -227,5 +227,5 @@
      (sno)                   local_address=130.75.105.113; local_host=lcmuk;;
      (levanto)               local_address=130.75.105.45;  local_host=lcmuk;;
-     (login*)                local_address=118.128.66.223; local_host=lckiaps;;
+     (login*)                local_address=118.128.66.201; local_host=lckiaps;;
      (maestro)               local_address=130.75.105.2;   local_host=lcmuk;;
      (meller)                local_address=134.106.74.155; local_host=lcfor;;
@@ -386,5 +386,5 @@
         (lckyoto) remote_address=133.3.51.11; submcom=/thin/local/bin/qsub;;
         (lck)     remote_address=165.132.26.61; submcom=/usr/torque/bin/qsub;;
-        (lckiaps) remote_address=118.128.66.223; submcom=/cm/shared/apps/pbspro/11.0.2.110766/bin/qsub;;
+        (lckiaps) remote_address=118.128.66.201; submcom=/opt/pbs/default/bin/qsub;;
         (lckordi) remote_address=210.219.61.8; submcom=/usr/torque/bin/qsub;;
         (lckyuh)  remote_address=133.5.4.33; submcom=/usr/bin/pjsub;;
@@ -450,5 +450,5 @@
                  esac;;
         (lckiaps) case  $ndq  in
-                     (express|normal)                        error=false;;
+                     (express|normal|normal20|quickq)        error=false;;
                      (*)                                     error=true;;
                  esac;;
@@ -974,5 +974,5 @@
     then
        cat > $job_to_send << %%END%%
-#!/bin/ksh
+#!/bin/bash
 #PBS -N $job_name
 #PBS -l walltime=$timestring
@@ -988,5 +988,5 @@
     else
        cat > $job_to_send << %%END%%
-#!/bin/ksh
+#!/bin/bash
 #PBS -N $job_name
 #PBS -l walltime=$timestring