Index: palm/trunk/SCRIPTS/.mrun.config.imuk_hlrnIII_rrtmg
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.imuk_hlrnIII_rrtmg	(revision 1945)
+++ palm/trunk/SCRIPTS/.mrun.config.imuk_hlrnIII_rrtmg	(revision 1948)
@@ -37,5 +37,5 @@
 %mopts             -j:4                                                        lcmuk parallel rrtmg
 %fopts             -fpe0:-O3:-cpp:-fp-model:source:-ftz:-fno-alias:-no-prec-div:-no-prec-sqrt:-ip:-nbs:-diag-disable:8290,8291:-I:/home/<replace_by_your_IMUK_username>/rrtmg/shared/include  lcmuk parallel rrtmg
-%lopts             -fpe0:-O3:-cpp:-fp-model:source:-ftz:-fno-alias:-no-prec-div:-no-prec-sqrt:-ip:-nbs:-diag-disable:8290,8291  lcmuk parallel rrtmg
+%lopts             -fpe0:-O3:-cpp:-fp-model:source:-ftz:-fno-alias:-no-prec-div:-no-prec-sqrt:-ip:-nbs:-diag-disable:8290,8291:-L/home/<replace_by_your_IMUK_username>/rrtmg/shared/lib:-lrrtmg  lcmuk parallel rrtmg
 #
 # IMUK debug/trace mode
@@ -50,5 +50,5 @@
 %fftw_lib          -L/muksoft/packages/fftw/3.3.4/lib64:-lfftw3                lcmuk parallel trace_rrtmg
 %fopts             -fpe0:-C:-check:nooutput_conversion:-debug:-traceback:-g:-w:-xT:-O0:-ftz:-fno-alias:-no-prec-div:-no-prec-sqrt:-ip:-nbs:-convert:little_endian:-diag-disable:8290,8291:-I:/home/<replace_by_your_IMUK_username>/rrtmg/static_trace/include  lcmuk parallel trace_rrtmg
-%lopts             -fpe0:-C:-check:nooutput_conversion:-debug:-traceback:-g:-w:-xT:-O0:-ftz:-fno-alias:-no-prec-div:-no-prec-sqrt:-ip:-nbs:-limf:-lm:-Vaxlib       lcmuk parallel trace_rrtmg
+%lopts             -fpe0:-C:-check:nooutput_conversion:-debug:-traceback:-g:-w:-xT:-O0:-ftz:-fno-alias:-no-prec-div:-no-prec-sqrt:-ip:-nbs:-limf:-lm:-Vaxlib:-L/home/<replace_by_your_IMUK_username>/rrtmg/static_trace/lib:-lrrtmg       lcmuk parallel trace_rrtmg
 #
 # HLRN-III Hannover
@@ -60,5 +60,5 @@
 %mopts               -j:4                                               lccrayh parallel rrtmg
 %fopts               -em:-O3:-hnoomp:-hfp3:-hdynamic:-I:/home/h/<replace_by_your_HLRN_username>/rrtmg/shared/include   lccrayh parallel rrtmg
-%lopts               -em:-O3:-hnoomp:-hfp3:-hdynamic:-dynamic           lccrayh parallel rrtmg
+%lopts               -em:-O3:-hnoomp:-hfp3:-hdynamic:-dynamic:-L/home/h/<replace_by_your_HLRN_username>/rrtmg/shared/lib:-lrrtmg           lccrayh parallel rrtmg
 %remote_username     <replace_by_your_HLRN-III_username>                lccrayh parallel rrtmg
 %memory              2300                                               lccrayh parallel rrtmg
@@ -73,5 +73,5 @@
 %mopts               -j:4                                               lccrayh parallel trace_rrtmg
 %fopts               -eD:-em:-g:-R:b:-K:trap=fp:-O0:-hnoomp:-I:/home/h/<replace_by_your_HLRN_username>/rrtmg/static_trace/include  lccrayh parallel trace_rrtmg
-%lopts               -eD:-em:-g:-R:b:-K:trap=fp:-O0:-hnoomp             lccrayh parallel trace_rrtmg
+%lopts               -eD:-em:-g:-R:b:-K:trap=fp:-O0:-hnoomp:-L/home/h/<replace_by_your_HLRN_username>/rrtmg/static_trace/lib:-lrrtmg             lccrayh parallel trace_rrtmg
 %remote_username     <replace_by_your_HLRN-III_username>                lccrayh parallel trace_rrtmg
 %memory              2300                                               lccrayh parallel trace_rrtmg
@@ -86,5 +86,5 @@
 %mopts               -j:4                                               lccrayb parallel rrtmg
 %fopts               -em:-O3:-hnoomp:-hfp3:-hdynamic:-I:/home/b/<replace_by_your_HLRN_username>/rrtmg/shared/include  lccrayb parallel rrtmg
-%lopts               -em:-O3:-hnoomp:-hfp3:-hdynamic:-dynamic           lccrayb parallel rrtmg
+%lopts               -em:-O3:-hnoomp:-hfp3:-hdynamic:-dynamic:-L/home/h/<replace_by_your_HLRN_username>/rrtmg/shared/lib:-lrrtmg           lccrayb parallel rrtmg
 %remote_username     <replace_by_your_HLRN-III_username>                lccrayb parallel rrtmg
 %memory              2300                                               lccrayb parallel rrtmg
@@ -99,5 +99,5 @@
 %mopts               -j:4                                               lccrayb parallel trace_rrtmg
 %fopts               -eD:-em:-g:-R:b:-K:trap=fp:-O0:-hnoomp:-I:/home/b/<replace_by_your_HLRN_username>/rrtmg/static_trace/include   lccrayb parallel trace_rrtmg
-%lopts               -eD:-em:-g:-R:b:-K:trap=fp:-O0:-hnoomp             lccrayb parallel trace_rrtmg
+%lopts               -eD:-em:-g:-R:b:-K:trap=fp:-O0:-hnoomp:-L/home/h/<replace_by_your_HLRN_username>/rrtmg/static_trace/lib:-lrrtmg             lccrayb parallel trace_rrtmg
 %remote_username     <replace_by_your_HLRN-III_username>                lccrayb parallel trace_rrtmg
 %memory              2300                                               lccrayb parallel trace_rrtmg