Index: palm/trunk/SCRIPTS/.mrun.config.csc_sisu
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.csc_sisu	(revision 1958)
+++ palm/trunk/SCRIPTS/.mrun.config.csc_sisu	(revision 1959)
@@ -82,4 +82,5 @@
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
+DATA_1D_FL_NETCDF        in:locopt     flf      $base_data/$fname/OUTPUT   _fl     nc
 DATA_1D_PR_NETCDF        in:locopt     prf      $base_data/$fname/OUTPUT   _pr     nc
 DATA_1D_SP_NETCDF        in:locopt     spf      $base_data/$fname/OUTPUT   _sp     nc
@@ -110,4 +111,5 @@
 TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
+DATA_1D_FL_NETCDF    out:loc:tr   fl#:flf   $base_data/$fname/OUTPUT  _fl     nc
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr     nc
 DATA_1D_SP_NETCDF    out:loc:tr   sp#:spf   $base_data/$fname/OUTPUT  _sp     nc
Index: palm/trunk/SCRIPTS/.mrun.config.cuhk
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.cuhk	(revision 1958)
+++ palm/trunk/SCRIPTS/.mrun.config.cuhk	(revision 1959)
@@ -87,4 +87,5 @@
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
+DATA_1D_FL_NETCDF        in:locopt     flf      $base_data/$fname/OUTPUT   _fl     nc
 DATA_1D_PR_NETCDF        in:locopt     prf      $base_data/$fname/OUTPUT   _pr     nc
 DATA_1D_SP_NETCDF        in:locopt     spf      $base_data/$fname/OUTPUT   _sp     nc
@@ -115,4 +116,5 @@
 TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
+DATA_1D_FL_NETCDF    out:loc:tr   fl#:flf   $base_data/$fname/OUTPUT  _fl     nc
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr     nc
 DATA_1D_SP_NETCDF    out:loc:tr   sp#:spf   $base_data/$fname/OUTPUT  _sp     nc
Index: palm/trunk/SCRIPTS/.mrun.config.dkrz
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.dkrz	(revision 1958)
+++ palm/trunk/SCRIPTS/.mrun.config.dkrz	(revision 1959)
@@ -89,4 +89,5 @@
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
+DATA_1D_FL_NETCDF        in:locopt     flf      $base_data/$fname/OUTPUT  _fl     nc
 DATA_1D_PR_NETCDF        in:locopt     prf      $base_data/$fname/OUTPUT   _pr     nc
 DATA_1D_SP_NETCDF        in:locopt     spf      $base_data/$fname/OUTPUT   _sp     nc
@@ -117,4 +118,5 @@
 TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
+DATA_1D_FL_NETCDF    out:loc:tr   fl#:flf   $base_data/$fname/OUTPUT  _fl      nc
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr      nc
 DATA_1D_SP_NETCDF    out:loc:tr   sp#:spf   $base_data/$fname/OUTPUT  _sp      nc
Index: palm/trunk/SCRIPTS/.mrun.config.forwind_flow
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.forwind_flow	(revision 1958)
+++ palm/trunk/SCRIPTS/.mrun.config.forwind_flow	(revision 1959)
@@ -116,4 +116,5 @@
 BININ                    in:loc:flpe   d3f:rec  $base_data/$fname/RESTART   _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART   _rprt
+DATA_1D_FL_NETCDF        in:locopt     flf      $output_data/$fname/OUTPUT  _fl     nc
 DATA_1D_PR_NETCDF        in:locopt     prf      $output_data/$fname/OUTPUT  _pr     nc
 DATA_1D_SP_NETCDF        in:locopt     spf      $output_data/$fname/OUTPUT  _sp     nc
@@ -153,4 +154,5 @@
 TURBINE_PARAMETERS10   out:loc:tr    d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters10
 #
+DATA_1D_FL_NETCDF      out:loc    fl#:flf   $output_data/$fname/OUTPUT  _fl      nc
 DATA_1D_PR_NETCDF      out:loc    pr#       $output_data/$fname/OUTPUT  _pr      nc
 DATA_1D_PR_NETCDF      out:loc    prf       $output_data/$fname/OUTPUT  _pr      nc
Index: palm/trunk/SCRIPTS/.mrun.config.forwind_hlrnIII
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.forwind_hlrnIII	(revision 1958)
+++ palm/trunk/SCRIPTS/.mrun.config.forwind_hlrnIII	(revision 1959)
@@ -140,4 +140,5 @@
 BININ                    in:loc:flpe   d3f:rec  $base_data/$fname/RESTART   _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART   _rprt
+DATA_1D_FL_NETCDF        in:locopt     flf      $output_data/$fname/OUTPUT  _fl     nc
 DATA_1D_PR_NETCDF        in:locopt     prf      $output_data/$fname/OUTPUT  _pr     nc
 DATA_1D_SP_NETCDF        in:locopt     spf      $output_data/$fname/OUTPUT  _sp     nc
@@ -177,4 +178,5 @@
 TURBINE_PARAMETERS10   out:loc:tr    d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters10
 #
+DATA_1D_FL_NETCDF      out:loc    fl#:flf   $base_data/$fname/OUTPUT    _fl      nc
 DATA_1D_PR_NETCDF      out:loc    pr#       $output_data/$fname/OUTPUT  _pr      nc
 DATA_1D_PR_NETCDF      out:loc    prf       $output_data/$fname/OUTPUT  _pr      nc
Index: palm/trunk/SCRIPTS/.mrun.config.gfortran
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.gfortran	(revision 1958)
+++ palm/trunk/SCRIPTS/.mrun.config.gfortran	(revision 1959)
@@ -102,4 +102,5 @@
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
+DATA_1D_FL_NETCDF        in:locopt     flf      $base_data/$fname/OUTPUT   _fl     nc
 DATA_1D_PR_NETCDF        in:locopt     prf      $base_data/$fname/OUTPUT   _pr     nc
 DATA_1D_SP_NETCDF        in:locopt     spf      $base_data/$fname/OUTPUT   _sp     nc
@@ -130,4 +131,5 @@
 TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
+DATA_1D_FL_NETCDF    out:loc:tr   fl#:flf   $base_data/$fname/OUTPUT  _fl     nc
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr     nc
 DATA_1D_SP_NETCDF    out:loc:tr   sp#:spf   $base_data/$fname/OUTPUT  _sp     nc
Index: palm/trunk/SCRIPTS/.mrun.config.hayaka
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.hayaka	(revision 1958)
+++ palm/trunk/SCRIPTS/.mrun.config.hayaka	(revision 1959)
@@ -74,4 +74,5 @@
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
+DATA_1D_FL_NETCDF        in:locopt     flf      $base_data/$fname/OUTPUT   _fl     nc
 DATA_1D_PR_NETCDF        in:locopt     prf      $base_data/$fname/OUTPUT   _pr     nc
 DATA_1D_SP_NETCDF        in:locopt     spf      $base_data/$fname/OUTPUT   _sp     nc
@@ -102,4 +103,5 @@
 TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
+DATA_1D_FL_NETCDF    out:loc:tr   fl#:flf   $base_data/$fname/OUTPUT  _fl     nc
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr     nc
 DATA_1D_SP_NETCDF    out:loc:tr   sp#:spf   $base_data/$fname/OUTPUT  _sp     nc
Index: palm/trunk/SCRIPTS/.mrun.config.hlrnIII
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.hlrnIII	(revision 1958)
+++ palm/trunk/SCRIPTS/.mrun.config.hlrnIII	(revision 1959)
@@ -141,4 +141,5 @@
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
+DATA_1D_FL_NETCDF        in:locopt     flf      $base_data/$fname/OUTPUT   _fl     nc
 DATA_1D_PR_NETCDF        in:locopt     prf      $base_data/$fname/OUTPUT   _pr     nc
 DATA_1D_SP_NETCDF        in:locopt     spf      $base_data/$fname/OUTPUT   _sp     nc
@@ -169,4 +170,5 @@
 TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
+DATA_1D_FL_NETCDF    out:loc:tr   fl#:flf   $base_data/$fname/OUTPUT  _fl     nc
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr     nc
 DATA_1D_SP_NETCDF    out:loc:tr   sp#:spf   $base_data/$fname/OUTPUT  _sp     nc
Index: palm/trunk/SCRIPTS/.mrun.config.ibmh
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.ibmh	(revision 1958)
+++ palm/trunk/SCRIPTS/.mrun.config.ibmh	(revision 1959)
@@ -87,4 +87,5 @@
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
+DATA_1D_FL_NETCDF        in:locopt     flf      $output_data   _fl     nc
 DATA_1D_PR_NETCDF        in:locopt     prf      $output_data   _pr     nc
 DATA_1D_SP_NETCDF        in:locopt     spf      $output_data   _sp     nc
@@ -115,4 +116,5 @@
 TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
+DATA_1D_FL_NETCDF    out:loc:tr   fl#:flf   $base_data/$fname/OUTPUT    _fl     nc
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $output_data/$fname/OUTPUT  _pr     nc
 DATA_1D_SP_NETCDF    out:loc:tr   sp#:spf   $output_data/$fname/OUTPUT  _sp     nc
Index: palm/trunk/SCRIPTS/.mrun.config.ifort
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.ifort	(revision 1958)
+++ palm/trunk/SCRIPTS/.mrun.config.ifort	(revision 1959)
@@ -102,4 +102,5 @@
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
+DATA_1D_FL_NETCDF        in:locopt     flf      $base_data/$fname/OUTPUT   _fl     nc
 DATA_1D_PR_NETCDF        in:locopt     prf      $base_data/$fname/OUTPUT   _pr     nc
 DATA_1D_SP_NETCDF        in:locopt     spf      $base_data/$fname/OUTPUT   _sp     nc
@@ -130,4 +131,5 @@
 TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
+DATA_1D_FL_NETCDF    out:loc:tr   fl#:flf   $base_data/$fname/OUTPUT  _fl     nc
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr     nc
 DATA_1D_SP_NETCDF    out:loc:tr   sp#:spf   $base_data/$fname/OUTPUT  _sp     nc
Index: palm/trunk/SCRIPTS/.mrun.config.imuk
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.imuk	(revision 1958)
+++ palm/trunk/SCRIPTS/.mrun.config.imuk	(revision 1959)
@@ -77,4 +77,5 @@
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
+DATA_1D_FL_NETCDF        in:locopt     flf      $base_data/$fname/OUTPUT  _fl     nc
 DATA_1D_PR_NETCDF        in:locopt     prf      $base_data/$fname/OUTPUT   _pr     nc
 DATA_1D_SP_NETCDF        in:locopt     spf      $base_data/$fname/OUTPUT   _sp     nc
@@ -105,4 +106,5 @@
 TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
+DATA_1D_FL_NETCDF    out:loc:tr   fl#:flf   $base_data/$fname/OUTPUT  _fl      nc
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr      nc
 DATA_1D_SP_NETCDF    out:loc:tr   sp#:spf   $base_data/$fname/OUTPUT  _sp      nc
Index: palm/trunk/SCRIPTS/.mrun.config.imuk_gpu
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.imuk_gpu	(revision 1958)
+++ palm/trunk/SCRIPTS/.mrun.config.imuk_gpu	(revision 1959)
@@ -89,4 +89,5 @@
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
+DATA_1D_FL_NETCDF        in:locopt     flf      $base_data/$fname/OUTPUT   _fl     nc
 DATA_1D_PR_NETCDF        in:locopt     prf      $base_data/$fname/OUTPUT   _pr     nc
 DATA_1D_SP_NETCDF        in:locopt     spf      $base_data/$fname/OUTPUT   _sp     nc
@@ -117,4 +118,5 @@
 TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
+DATA_1D_FL_NETCDF    out:loc:tr   fl#:flf   $base_data/$fname/OUTPUT  _fl      nc
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr      nc
 DATA_1D_SP_NETCDF    out:loc:tr   sp#:spf   $base_data/$fname/OUTPUT  _sp      nc
Index: palm/trunk/SCRIPTS/.mrun.config.imuk_hlrnIII
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.imuk_hlrnIII	(revision 1958)
+++ palm/trunk/SCRIPTS/.mrun.config.imuk_hlrnIII	(revision 1959)
@@ -138,4 +138,5 @@
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
+DATA_1D_FL_NETCDF        in:locopt     flf      $base_data/$fname/OUTPUT   _fl     nc
 DATA_1D_PR_NETCDF        in:locopt     prf      $base_data/$fname/OUTPUT   _pr     nc
 DATA_1D_SP_NETCDF        in:locopt     spf      $base_data/$fname/OUTPUT   _sp     nc
@@ -166,4 +167,5 @@
 TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
+DATA_1D_FL_NETCDF    out:loc:tr   fl#:flf   $base_data/$fname/OUTPUT  _fl      nc
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr      nc
 DATA_1D_SP_NETCDF    out:loc:tr   sp#:spf   $base_data/$fname/OUTPUT  _sp      nc
Index: palm/trunk/SCRIPTS/.mrun.config.imuk_hlrnIII_rrtmg
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.imuk_hlrnIII_rrtmg	(revision 1958)
+++ palm/trunk/SCRIPTS/.mrun.config.imuk_hlrnIII_rrtmg	(revision 1959)
@@ -141,4 +141,5 @@
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
+DATA_1D_FL_NETCDF        in:locopt     flf      $base_data/$fname/OUTPUT   _fl     nc
 DATA_1D_PR_NETCDF        in:locopt     prf      $base_data/$fname/OUTPUT   _pr     nc
 DATA_1D_SP_NETCDF        in:locopt     spf      $base_data/$fname/OUTPUT   _sp     nc
@@ -169,4 +170,5 @@
 TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
+DATA_1D_FL_NETCDF    out:loc:tr   fl#:flf   $base_data/$fname/OUTPUT  _fl      nc
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr      nc
 DATA_1D_SP_NETCDF    out:loc:tr   sp#:spf   $base_data/$fname/OUTPUT  _sp      nc
Index: palm/trunk/SCRIPTS/.mrun.config.imuknb
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.imuknb	(revision 1958)
+++ palm/trunk/SCRIPTS/.mrun.config.imuknb	(revision 1959)
@@ -86,4 +86,5 @@
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
+DATA_1D_FL_NETCDF        in:locopt     flf      $base_data/$fname/OUTPUT   _fl     nc
 DATA_1D_PR_NETCDF        in:locopt     prf      $base_data/$fname/OUTPUT   _pr     nc
 DATA_1D_SP_NETCDF        in:locopt     spf      $base_data/$fname/OUTPUT   _sp     nc
@@ -114,4 +115,5 @@
 TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
+DATA_1D_FL_NETCDF    out:loc:tr   fl#:flf   $base_data/$fname/OUTPUT  _fl     nc
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr     nc
 DATA_1D_SP_NETCDF    out:loc:tr   sp#:spf   $base_data/$fname/OUTPUT  _sp     nc
Index: palm/trunk/SCRIPTS/.mrun.config.kiaps
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.kiaps	(revision 1958)
+++ palm/trunk/SCRIPTS/.mrun.config.kiaps	(revision 1959)
@@ -74,4 +74,5 @@
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
+DATA_1D_FL_NETCDF        in:locopt     flf      $base_data/$fname/OUTPUT   _fl     nc
 DATA_1D_PR_NETCDF        in:locopt     prf      $base_data/$fname/OUTPUT   _pr     nc
 DATA_1D_SP_NETCDF        in:locopt     spf      $base_data/$fname/OUTPUT   _sp     nc
@@ -102,4 +103,5 @@
 TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
+DATA_1D_FL_NETCDF    out:loc:tr   fl#:flf   $base_data/$fname/OUTPUT  _fl     nc
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr     nc
 DATA_1D_SP_NETCDF    out:loc:tr   sp#:spf   $base_data/$fname/OUTPUT  _sp     nc
Index: palm/trunk/SCRIPTS/.mrun.config.lcxe6
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.lcxe6	(revision 1958)
+++ palm/trunk/SCRIPTS/.mrun.config.lcxe6	(revision 1959)
@@ -98,4 +98,5 @@
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
+DATA_1D_FL_NETCDF        in:locopt     flf      $base_data/$fname/OUTPUT   _fl     nc
 DATA_1D_PR_NETCDF        in:locopt     prf      $base_data/$fname/OUTPUT   _pr     nc
 DATA_1D_SP_NETCDF        in:locopt     spf      $base_data/$fname/OUTPUT   _sp     nc
@@ -126,4 +127,5 @@
 TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
+DATA_1D_FL_NETCDF    out:loc:tr   fl#:flf   $base_data/$fname/OUTPUT  _fl     nc
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr     nc
 DATA_1D_SP_NETCDF    out:loc:tr   sp#:spf   $base_data/$fname/OUTPUT  _sp     nc
Index: palm/trunk/SCRIPTS/.mrun.config.riam
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.riam	(revision 1958)
+++ palm/trunk/SCRIPTS/.mrun.config.riam	(revision 1959)
@@ -84,4 +84,5 @@
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
+DATA_1D_FL_NETCDF        in:locopt     flf      $base_data/$fname/OUTPUT   _fl     nc
 DATA_1D_PR_NETCDF        in:locopt     prf      $base_data/$fname/OUTPUT   _pr     nc
 DATA_1D_SP_NETCDF        in:locopt     spf      $base_data/$fname/OUTPUT   _sp     nc
@@ -112,4 +113,5 @@
 TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
+DATA_1D_FL_NETCDF    out:loc:tr   fl#:flf   $base_data/$fname/OUTPUT  _fl     nc
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr     nc
 DATA_1D_SP_NETCDF    out:loc:tr   sp#:spf   $base_data/$fname/OUTPUT  _sp     nc
Index: palm/trunk/SCRIPTS/.mrun.config.tatara
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.tatara	(revision 1958)
+++ palm/trunk/SCRIPTS/.mrun.config.tatara	(revision 1959)
@@ -73,4 +73,5 @@
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
+DATA_1D_FL_NETCDF        in:locopt     flf      $base_data/$fname/OUTPUT   _fl     nc
 DATA_1D_PR_NETCDF        in:locopt     prf      $base_data/$fname/OUTPUT   _pr     nc
 DATA_1D_SP_NETCDF        in:locopt     spf      $base_data/$fname/OUTPUT   _sp     nc
@@ -101,4 +102,5 @@
 TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
+DATA_1D_FL_NETCDF    out:loc:tr   fl#:flf   $base_data/$fname/OUTPUT  _fl     nc
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr     nc
 DATA_1D_SP_NETCDF    out:loc:tr   sp#:spf   $base_data/$fname/OUTPUT  _sp     nc
Index: palm/trunk/SCRIPTS/.mrun.config.yonsei2011
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.yonsei2011	(revision 1958)
+++ palm/trunk/SCRIPTS/.mrun.config.yonsei2011	(revision 1959)
@@ -86,4 +86,5 @@
 BININ                    in:loc:flpe   d3f:rec   $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf  $base_data/$fname/RESTART  _rprt
+DATA_1D_FL_NETCDF        in:locopt     flf   $base_data/$fname/OUTPUT   _fl     nc
 DATA_1D_PR_NETCDF        in:locopt     prf   $base_data/$fname/OUTPUT   _pr     nc
 DATA_1D_SP_NETCDF        in:locopt     spf   $base_data/$fname/OUTPUT   _sp     nc
@@ -119,4 +120,5 @@
 LIST_PROFIL       out:loc:tr   d3#     $base_data/$fname/MONITORING  _list_pr
 #
+DATA_1D_FL_NETCDF out:loc:tr   fl#:flf $base_data/$fname/OUTPUT      _fl  nc
 DATA_1D_PR_NETCDF out:loc:tr   pr#:prf $base_data/$fname/OUTPUT      _pr  nc
 #DATA_1D_PR_NETCDF out:loc      pr#:prf $base_data/$fname/OUTPUT      _pr  nc